SystemOrganization addCategory: #ConfigurationOfMyPaint!

Object subclass: #ConfigurationOfMyPaint
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMyPaint'!

!ConfigurationOfMyPaint class methodsFor: 'development support' stamp: 'JPSA 4/18/2012 17:04'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMyPaint class methodsFor: 'private' stamp: 'JPSA 4/18/2012 17:04'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMyPaint class methodsFor: 'private' stamp: 'JPSA 4/18/2012 17:04'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMyPaint class methodsFor: 'private' stamp: 'JPSA 4/18/2012 17:04'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMyPaint class methodsFor: 'metacello tool support' stamp: 'JPSA 4/18/2012 17:04'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMyPaint class methodsFor: 'loading' stamp: 'JPSA 4/18/2012 17:04'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMyPaint class methodsFor: 'loading' stamp: 'JPSA 4/18/2012 17:04'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMyPaint class methodsFor: 'loading' stamp: 'JPSA 4/18/2012 17:04'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMyPaint class methodsFor: 'accessing' stamp: 'JPSA 4/18/2012 17:04'!
project

	^self new project! !

!ConfigurationOfMyPaint class methodsFor: 'development support' stamp: 'JPSA 4/18/2012 17:04'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMyPaint methodsFor: 'baselines' stamp: 'JPSA 4/18/2012 17:04'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/VersionnerCacheTest'.
		spec 
			package: 'MyPaint-Core';
			package: 'MyPaint-Test'.
		spec group: 'default' with: #('MyPaint-Core' 'MyPaint-Test' ). ].
! !

!ConfigurationOfMyPaint methodsFor: 'symbolic versions' stamp: 'JPSA 4/18/2012 17:53'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.2'.
! !

!ConfigurationOfMyPaint methodsFor: 'accessing' stamp: 'JPSA 4/18/2012 17:04'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMyPaint methodsFor: 'versions' stamp: 'JPSA 4/18/2012 17:47'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : a simple comment'.
		spec author: 'JPSA'.
		spec timestamp: '4/18/2012 17:47'.
		spec 
			package: 'MyPaint-Core' with: 'MyPaint-Core-JPSA.3';
			package: 'MyPaint-Test' with: 'MyPaint-Test-JPSA.3'. ].
! !

!ConfigurationOfMyPaint methodsFor: 'versions' stamp: 'JPSA 4/18/2012 17:53'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : a simple comment
1.1 : adding class MyCircle'.
		spec author: 'JPSA'.
		spec timestamp: '4/18/2012 17:53'.
		spec 
			package: 'MyPaint-Core' with: 'MyPaint-Core-JPSA.4';
			package: 'MyPaint-Test' with: 'MyPaint-Test-JPSA.3'. ].
! !

!ConfigurationOfMyPaint methodsFor: 'versions' stamp: 'JPSA 4/18/2012 17:53'!
version12: spec
	<version: '1.2' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.1 : adding class MyCircle'.
		spec author: 'JPSA'.
		spec timestamp: '4/18/2012 17:53'.
		spec 
			package: 'MyPaint-Core' with: 'MyPaint-Core-JPSA.4';
			package: 'MyPaint-Test' with: 'MyPaint-Test-JPSA.3'. ].
! !
